Bug 94139 - [regression, HSW, IVB] piglit.spec.arb_compute_shader.minmax
Summary: [regression, HSW, IVB] piglit.spec.arb_compute_shader.minmax
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965 (show other bugs)
Version: git
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Samuel Pitoiset
QA Contact: Intel 3D Bugs Mailing List
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2016-02-13 21:32 UTC by Mark Janes
Modified: 2016-02-14 00:19 UTC (History)
3 users (show)

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Mark Janes 2016-02-13 21:32:32 UTC
Haswell and Ivybridge systems running stock linux 4.4 began failing this test, bisected to:

be27f772e8b97031bf5177523a74ff8738d5adee
Author:     Samuel Pitoiset <samuel.pitoiset@gmail.com>
mesa: do not use a constant for MAX_COMPUTE_SHARED_SIZE

This will allow to query the underlying drivers for the maximum
total storage size of all variables declared as <shared> with
PIPE_COMPUTE_CAP_MAX_LOCAL_SIZE.

Signed-off-by: Samuel Pitoiset <samuel.pitoiset@gmail.com>
Reviewed-by: Marek Olšák <marek.olsak@amd.com>
Reviewed-by: Ilia Mirkin <imirkin@alum.mit.edu>

standard out from the test:
/tmp/build_root/m64/lib/piglit/bin/arb_compute_shader-minmax -auto -fbo
piglit: debug: Requested an OpenGL 3.1 Forward-Compatible Core Context, and received a matching 3.3 context

token                                               minimum    value
GL_MAX_COMPUTE_WORK_GROUP_COUNT[0]                    65535    65535
GL_MAX_COMPUTE_WORK_GROUP_COUNT[1]                    65535    65535
GL_MAX_COMPUTE_WORK_GROUP_COUNT[2]                    65535    65535
GL_MAX_COMPUTE_WORK_GROUP_SIZE[0]                      1024     1120
GL_MAX_COMPUTE_WORK_GROUP_SIZE[1]                      1024     1120
GL_MAX_COMPUTE_WORK_GROUP_SIZE[2]                        64     1120
GL_MAX_COMPUTE_WORK_GROUP_INVOCATIONS                  1024     1120
GL_MAX_COMPUTE_UNIFORM_BLOCKS                            12       14
GL_MAX_COMPUTE_TEXTURE_IMAGE_UNITS                       16       32
GL_MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS                     8       16
GL_MAX_COMPUTE_ATOMIC_COUNTERS                            8     4096
GL_MAX_COMPUTE_UNIFORM_COMPONENTS                       512    16384
GL_MAX_COMPUTE_IMAGE_UNIFORMS                             8       32

Standard Error

GL_MAX_COMPUTE_SHARED_MEMORY_SIZE                     32768        0 (ERROR)
Comment 1 Ilia Mirkin 2016-02-13 21:36:49 UTC
Ah right, that commit should have set it to the previously-default value (32768) for i965/gen7+. [And perhaps you might want to advertise a larger size, 32K seems potentially low.]
Comment 2 Samuel Pitoiset 2016-02-13 21:51:59 UTC
Hi,

Thanks for reporting this.

The bugfix is on mesa-dev.
https://lists.freedesktop.org/archives/mesa-dev/2016-February/107562.html

Thanks.
Comment 3 Samuel Pitoiset 2016-02-13 22:18:44 UTC
This should fix the issue:

commit 40fcb6b9f95050370af0fef11abd12e16b8cc7d0
Author: Samuel Pitoiset <samuel.pitoiset@gmail.com>
Date:   Sat Feb 13 22:49:37 2016 +0100

    i965: fix MAX_COMPUTE_SHARED_SIZE constant value
    
    MAX_COMPUTE_SHARED_SIZE should be set to 32768. This fixes a regression
    introduced in be27f77 (mesa: do not use a constant for
    MAX_COMPUTE_SHARED_SIZE).
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94139
    Signed-off-by: Samuel Pitoiset <samuel.pitoiset@gmail.com>
    Reviewed-by: Jordan Justen <jordan.l.justen@intel.com>
    Reviewed-by: Ilia Mirkin <imirkin@alum.mit.edu>
    Reviewed-by: Kenneth Graunke <kenneth@whitecape.org>


bug/show.html.tmpl processed on Jan 18, 2017 at 04:11:28.
(provided by the Example extension).